
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Qa_measurementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_measurements = await db.qa_measurements.create(
            {
                id: data.id || undefined,
        
        result: data.result
        ||
        null
            ,
            
        numeric_value: data.numeric_value
        ||
        null
            ,
            
        text_value: data.text_value
        ||
        null
            ,
            
        recorded_at: data.recorded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await qa_measurements.setQa_inspection( data.qa_inspection || null, {
            transaction,
        });
        
        await qa_measurements.setQa_checklist_item( data.qa_checklist_item || null, {
            transaction,
        });
        
        await qa_measurements.setRecorded_by( data.recorded_by || null, {
            transaction,
        });
        

        

        

        return qa_measurements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const qa_measurementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                result: item.result
            ||
            null
            ,
            
                numeric_value: item.numeric_value
            ||
            null
            ,
            
                text_value: item.text_value
            ||
            null
            ,
            
                recorded_at: item.recorded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const qa_measurements = await db.qa_measurements.bulkCreate(qa_measurementsData, { transaction });

        // For each item created, replace relation files
        

        return qa_measurements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const qa_measurements = await db.qa_measurements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.result !== undefined) updatePayload.result = data.result;
        
        
        if (data.numeric_value !== undefined) updatePayload.numeric_value = data.numeric_value;
        
        
        if (data.text_value !== undefined) updatePayload.text_value = data.text_value;
        
        
        if (data.recorded_at !== undefined) updatePayload.recorded_at = data.recorded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await qa_measurements.update(updatePayload, {transaction});

        
        
        if (data.qa_inspection !== undefined) {
            await qa_measurements.setQa_inspection(
              
              data.qa_inspection,
              
              { transaction }
            );
        }
        
        if (data.qa_checklist_item !== undefined) {
            await qa_measurements.setQa_checklist_item(
              
              data.qa_checklist_item,
              
              { transaction }
            );
        }
        
        if (data.recorded_by !== undefined) {
            await qa_measurements.setRecorded_by(
              
              data.recorded_by,
              
              { transaction }
            );
        }
        

        
        

        

        return qa_measurements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const qa_measurements = await db.qa_measurements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of qa_measurements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of qa_measurements) {
                await record.destroy({transaction});
            }
        });


        return qa_measurements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const qa_measurements = await db.qa_measurements.findByPk(id, options);

        await qa_measurements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await qa_measurements.destroy({
            transaction
        });

        return qa_measurements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const qa_measurements = await db.qa_measurements.findOne(
            { where },
            { transaction },
        );

        if (!qa_measurements) {
            return qa_measurements;
        }

        const output = qa_measurements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.qa_inspection = await qa_measurements.getQa_inspection({
            transaction
        });
        
        
        output.qa_checklist_item = await qa_measurements.getQa_checklist_item({
            transaction
        });
        
        
        output.recorded_by = await qa_measurements.getRecorded_by({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.qa_inspections,
        as: 'qa_inspection',
        
        where: filter.qa_inspection ? {
          [Op.or]: [
            { id: { [Op.in]: filter.qa_inspection.split('|').map(term => Utils.uuid(term)) } },
            {
              inspection_number: {
                [Op.or]: filter.qa_inspection.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.qa_checklist_items,
        as: 'qa_checklist_item',
        
        where: filter.qa_checklist_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.qa_checklist_item.split('|').map(term => Utils.uuid(term)) } },
            {
              check_name: {
                [Op.or]: filter.qa_checklist_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'recorded_by',
        
        where: filter.recorded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.recorded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.recorded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.text_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'qa_measurements',
                        'text_value',
                        filter.text_value,
                    ),
                };
            }
            

            
            

            
            if (filter.numeric_valueRange) {
                const [start, end] = filter.numeric_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    numeric_value: {
                    ...where.numeric_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    numeric_value: {
                    ...where.numeric_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.recorded_atRange) {
                const [start, end] = filter.recorded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    recorded_at: {
                    ...where.recorded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    recorded_at: {
                    ...where.recorded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.result) {
                where = {
                    ...where,
                result: filter.result,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.qa_measurements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'qa_measurements',
                        'text_value',
                        query,
                    ),
                ],
            };
        }

        const records = await db.qa_measurements.findAll({
            attributes: [ 'id', 'text_value' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['text_value', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.text_value,
        }));
    }

    
};

